//---------------------------------------------------------------------------

#pragma hdrstop

#include <stdio.h>
#include "wuvorbisfile.h"



//---------------------------------------------------------------------------
// eR[obN֐̏
//---------------------------------------------------------------------------
static size_t _cdecl cb_read_func(void *ptr, size_t size, size_t nmemb, void *datasource)
{
	return fread(ptr, size, nmemb, (FILE*)datasource);
}
//---------------------------------------------------------------------------
static int _cdecl cb_seek_func(void *datasource, wu_ogg_int64_t offset, int whence)
{
	return fseek((FILE*)datasource, (long)offset, whence);
}
//---------------------------------------------------------------------------
static int _cdecl cb_close_func(void *datasource)
{
	return fclose((FILE*)datasource);
}
//---------------------------------------------------------------------------
static long _cdecl cb_tell_func(void *datasource)
{
	return ftell((FILE*)datasource);
}
//---------------------------------------------------------------------------




//---------------------------------------------------------------------------
// main ֐
//---------------------------------------------------------------------------
#pragma argsused
//---------------------------------------------------------------------------
int main(int argc, char* argv[])
{
	// `FbN
	if(argc < 3)
	{
		fprintf(stderr, "Usage: wu_decapi_test <input_vorbis_stream.ogg> <output_raw_pcm_file> [<path_to_wuvorbis.dll>]\n");
	}

	const char *wuvorbis_dll = argc >= 4 ? argv[3] : NULL;

	// WuVorbis 
	// WuVorbisInit  wuvorbis.dll ̃t@CŁANULL Ȃ
	// ftHǧpX̃t@Cg (LoadLibrary("wuborbis.dll") )
	// WuvVorbisInit ĂяoȂƁAwu_ ɂ֐̌Ăяoׂ͂
	// ŝŒӁB
	if(WuVorbisInit(wuvorbis_dll))
	{
		fprintf(stderr, "Cannot load or incorrect wuvorbis.dll\n");
		return 3;
	}

	// CPU `FbN CPU gp@\̐ݒ
	// wu_DetectCPU  CPU @\擾邽߂ɎgB
	// ʏAwu_DetectCPU ̖߂l̂܂ wu_SetCPUType ɓn
	// gBwu_SetCPUType gȂƁASSE  3DNow! Ȃǂ CPU g@\
	// ܂gȂ̂ŒӂB
	// wu_SetCPUType ݂rbǵAwu_DetectCPU Ԃl̂
	// #define WU_CPU_HAS_MMX 0x000020000
	// #define WU_CPU_HAS_3DN 0x000040000
	// #define WU_CPU_HAS_SSE 0x000080000
	// ̂RłB
	unsigned __int32 cputype = wu_DetectCPU();
	wu_SetCPUType(cputype);

	// t@CJ
	FILE *file = fopen(argv[1], "rb");
	if(!file)
	{
		// t@CJȂ
		WuVorbisUninit();
		fprintf(stderr, "Cannot open %s\n", argv[1]);
		return 3;
	}

	FILE *outfile = fopen(argv[2], "wb");
	if(!outfile)
	{
		// t@CJȂ
		fclose(file);
		WuVorbisUninit();
		fprintf(stderr, "Cannot open %s\n", argv[2]);
		return 3;
	}

	// R[obN֐̃ZbgAbv
	wu_ov_callbacks callbacks = {cb_read_func, cb_seek_func, cb_close_func, cb_tell_func};

	// wu_og_open_callbacks gpĊJ
	wu_OggVorbis_File ovfile;

	if(wu_ov_open_callbacks((void*)file, &ovfile, NULL, 0, callbacks) < 0)
	{
		// t@C𐳏ɊJȂ
		fclose(file);
		fclose(outfile);
		WuVorbisUninit();
		fprintf(stderr, "Cannot open %s (in ov_open_callbacks)\n", argv[1]);
		return 3;
	}

	// \
	wu_vorbis_info *info = wu_ov_info(&ovfile, -1);

	if(!info)
	{
		wu_ov_clear(&ovfile);
		fclose(outfile);
		WuVorbisUninit();
		fprintf(stderr, "ov_info failed\n", argv[1]);
		return 3;
	}

	fprintf(stderr,
		"version   : %d\n"
		"channels  : %d\n"
		"rate      : %d\n"
		"bitrate_upper   : %d\n"
		"bitrate_nominal : %d\n"
		"bitrate_lower   : %d\n"
		"bitrate_window  : %d\n",
		info->version, info->channels, info->rate, info->bitrate_upper,
		info->bitrate_nominal, info->bitrate_lower, info->bitrate_window);

	// fR[hĂ݂
	// ̃eXgvOo͂fR[hʂ raw pcm Ȃ̂Œ
	int section = -1;
	while(true)
	{
		char buf[1024];
		// wu_ov_read  bigendianp  0A
		// word  2(16bit signed integer)  4 (32bit float) A
		// signed  1 ̕Kv
		int res = wu_ov_read(&ovfile, buf, 1024, 0, 2, 1, &section);
		// wu_ov_read ͗vꂽTCY𖞂ɋAꍇ̂ŒӁB
		// 0 ߂΃fR[hIA̐߂
		// fR[h(߂l͏܂ꂽoCg)A
		// ̐߂ꍇ̓pPbgsŃfR[hłȂB
		//  (lbg[ÑXg[~OƂłȂĂ̏󋵂͔)
		// ̐߂ꍇ́Aǂݎ悤ɂȂ܂
		// ̂܂ wu_ov_read JԂ΂悢

		if(res == 0) break; // fR[hI
		if(res > 0)	fwrite(buf, 1, res, outfile);
	}

	// wu_ov_clear  ovfile \̂NA
	wu_ov_clear(&ovfile);
	// (̓t@C ov_clear  cb_close_func ĂяoĎIɕ̂łł͕Ȃ)

	// o̓t@C
	fclose(outfile);

	// WuVorbis I
	// ʏ Windows ̓AvP[VIɎI DLL ̂
	// ͕KvȂBBB
	WuVorbisUninit();

	return 0;
}
//---------------------------------------------------------------------------
